#ifndef	_SYSTEM_H_
#define	_SYSTEM_H_

#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#ifndef ALIBC_OLD
#include <util/delay.h>
#else
#include <avr/delay.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include "config.h"


//-----------------------------------------------------------------------------
// UTILITY DEFINATION
#define Sbi(Port, Value)        	(Port |= Value)
#define Cbi(Port, Value)            (Port &= (~Value))
#define Tbi(Port, Value)            (Port ^= Value)

#define MSB(x)    					(((x) >> 8) & 0xFF)
#define LSB(x)    					((x) & 0xFF)
#define ABS(x)						((x<0)?x:x*=-1))

#define TRUE						1
#define FALSE						0

#define BIT0						0x01
#define BIT1						0x02
#define BIT2						0x04
#define BIT3						0x08
#define BIT4						0x10
#define BIT5						0x20
#define BIT6						0x40
#define BIT7						0x80
//-----------------------------------------------------------------------------

// Enter interrupt	
#define enable()  __asm__ __volatile__ ("sei" ::)
#define disable() __asm__ __volatile__ ("cli" ::)

//-----------------------------------------------------------------------------
//SYSTEM Fuction Declaration
void SystemInit(void);
void Delay(unsigned int Time);
//-----------------------------------------------------------------------------
#endif
