
#define AVR_TYPE_MEGA128			1
#define AVR_TYPE_MEGA8				0
#define AVR_CLK_8MHZ				8000000
#define AVR_CLK_16MHZ				16000000
#define AVR_CLK_7362KHZ				16000000
#define AVR_CLK_147456HZ			14745600

#define __MCU_TYPE__				AVR_TYPE_MEGA128
#define __SYS_CLK__					AVR_CLK_8MHZ

#define _UART0_ENABLE

//-----------------------------------------------------------------------------
// On board LED
#define Led1Init()					DDRB |= (1<<DDB4);
#define Led1Off()					PORTB |= (1<<PB4);
#define Led1On()					PORTB &= ~(1<<PB4);

// EXP LED
#define Led2Init()					DDRB |= (1<<DDB6);
#define Led2Off()					PORTB |= (1<<PB6);
#define Led2On()					PORTB &= ~(1<<PB6);

#define Led3Init()					DDRB |= (1<<DDB7);
#define Led3Off()					PORTB |= (1<<PB7);
#define Led3On()					PORTB &= ~(1<<PB7);
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Switch Driver
#define SW1_BIT						BIT4
#define SW1_PORT					PORTE
#define Sw1Init()					Cbi(DDRE, SW1_BIT)
#define GetSw1()					!(PINE&SW1_BIT)
#define WaitForSw1()				while(GetSw1())

#define SW2_BIT						BIT5
#define SW2_PORT					PORTE
#define Sw2Init()					Cbi(DDRE, SW2_BIT)
#define GetSw2()					!(PINE&SW2_BIT)
#define WaitForSw2()				while(GetSw2())

#define SW3_BIT						BIT4
#define SW3_PORT					PORTD
#define Sw3Init()					Cbi(DDRD, SW3_BIT)
#define GetSw4()					!(PIND&SW3_BIT)
#define WaitForSw3()				while(GetSw3())
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Buzzer Driver
#define BUZZER_BIT					BIT5
#define BUZZER_INIT()				Sbi(DDRB, BUZZER_BIT);BUZZER_OFF()
#define BUZZER_ON()					Cbi(PORTB, BUZZER_BIT)
#define BUZZER_OFF()				Sbi(PORTB, BUZZER_BIT)
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// ENC28J60 HAL
#define SPI_INIT()					SPI0_Init();SPCR = (1<<MSTR) | (1<<SPE);
#define SPI_WRITE					SPI0_WriteByte
#define SPI_READ					SPI0_RxData

// ENC28J60 CS
#define ENC28J60_CONTROL_PORT   	PORTC
#define ENC28J60_CONTROL_DDR    	DDRC
#define ENC28J60_CONTROL_CS     	4
// set CS to 0 = active
#define CSACTIVE 					ENC28J60_CONTROL_PORT&=~(1<<ENC28J60_CONTROL_CS)
// set CS to 1 = passive
#define 							CSPASSIVE ENC28J60_CONTROL_PORT|=(1<<ENC28J60_CONTROL_CS)
#define ENC28J60_CONTROL_INIT()		ENC28J60_CONTROL_DDR |= 1<<ENC28J60_CONTROL_CS
//-----------------------------------------------------------------------------

#define INIT_DRV_PORT()				DDRA = 0xFF;PORTA=0xFF
#define SelectDriver(Num)			(PORTA = ~(1<<(Num)))


#define INIT_GREEN_PORT()			DDRC = 0xFF;PORTC=0xFF
#define INIT_RED_PORT()				DDRB |= 0x0F;DDRD |= 0xF0;PORTB |= 0x0F;PORTD |=0xF0
#define OutGreenData(Data)			PORTC = ~(Data)

